# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from uga_tum_ardrone/filter_state.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class filter_state(genpy.Message):
  _md5sum = "33f8050d082c4ebadff26def43dcfd15"
  _type = "uga_tum_ardrone/filter_state"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# constants
uint32 PTAM_IDLE = 0           # PTAM not running.
uint32 PTAM_INITIALIZING = 1   # initialization (trails)
uint32 PTAM_LOST = 2           # ptam is running, but lost
uint32 PTAM_GOOD = 3           # tracking quality OK
uint32 PTAM_BEST = 4           # tracking quality best
uint32 PTAM_TOOKKF = 5         # just took a new KF (equivalent to PTAM_BEST)
uint32 PTAM_FALSEPOSITIVE = 6  # ptam thinks it is good, but its estimate is rejected.

# header
Header      header

# ----------------- raw 10d filter state ----------------------------
float32     x
float32     y
float32     z
float32     dx
float32     dy
float32     dz
float32     roll
float32     pitch
float32     yaw
float32     dyaw



# --------------------- other values ---------------------------
float32     scale         # ptam scale factor (PTAMpos * scale = WORLDpos).
uint32      ptamState
float32     scaleAccuracy # if scale is very inaccurate, this is about 0.5, and grows up to 1 (=very accurate).


# ----------------- propagated from drone messages: -----------------
# 0: Unknown, 1: Init, 2: Landed, 3: Flying, 4: Hovering, 5: Test
# 6: Taking off, 7: Goto Fix Point, 8: Landing, 9: Looping
# Note: 3,7 seems to discriminate type of flying (isFly = 3 | 7)
uint32       droneState
float32      batteryPercent    # 0 means no battery, 100 means full battery

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  # Pseudo-constants
  PTAM_IDLE = 0
  PTAM_INITIALIZING = 1
  PTAM_LOST = 2
  PTAM_GOOD = 3
  PTAM_BEST = 4
  PTAM_TOOKKF = 5
  PTAM_FALSEPOSITIVE = 6

  __slots__ = ['header','x','y','z','dx','dy','dz','roll','pitch','yaw','dyaw','scale','ptamState','scaleAccuracy','droneState','batteryPercent']
  _slot_types = ['std_msgs/Header','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','uint32','float32','uint32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,x,y,z,dx,dy,dz,roll,pitch,yaw,dyaw,scale,ptamState,scaleAccuracy,droneState,batteryPercent

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(filter_state, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.x is None:
        self.x = 0.
      if self.y is None:
        self.y = 0.
      if self.z is None:
        self.z = 0.
      if self.dx is None:
        self.dx = 0.
      if self.dy is None:
        self.dy = 0.
      if self.dz is None:
        self.dz = 0.
      if self.roll is None:
        self.roll = 0.
      if self.pitch is None:
        self.pitch = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.dyaw is None:
        self.dyaw = 0.
      if self.scale is None:
        self.scale = 0.
      if self.ptamState is None:
        self.ptamState = 0
      if self.scaleAccuracy is None:
        self.scaleAccuracy = 0.
      if self.droneState is None:
        self.droneState = 0
      if self.batteryPercent is None:
        self.batteryPercent = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.x = 0.
      self.y = 0.
      self.z = 0.
      self.dx = 0.
      self.dy = 0.
      self.dz = 0.
      self.roll = 0.
      self.pitch = 0.
      self.yaw = 0.
      self.dyaw = 0.
      self.scale = 0.
      self.ptamState = 0
      self.scaleAccuracy = 0.
      self.droneState = 0
      self.batteryPercent = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_11fIfIf.pack(_x.x, _x.y, _x.z, _x.dx, _x.dy, _x.dz, _x.roll, _x.pitch, _x.yaw, _x.dyaw, _x.scale, _x.ptamState, _x.scaleAccuracy, _x.droneState, _x.batteryPercent))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 60
      (_x.x, _x.y, _x.z, _x.dx, _x.dy, _x.dz, _x.roll, _x.pitch, _x.yaw, _x.dyaw, _x.scale, _x.ptamState, _x.scaleAccuracy, _x.droneState, _x.batteryPercent,) = _struct_11fIfIf.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_11fIfIf.pack(_x.x, _x.y, _x.z, _x.dx, _x.dy, _x.dz, _x.roll, _x.pitch, _x.yaw, _x.dyaw, _x.scale, _x.ptamState, _x.scaleAccuracy, _x.droneState, _x.batteryPercent))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 60
      (_x.x, _x.y, _x.z, _x.dx, _x.dy, _x.dz, _x.roll, _x.pitch, _x.yaw, _x.dyaw, _x.scale, _x.ptamState, _x.scaleAccuracy, _x.droneState, _x.batteryPercent,) = _struct_11fIfIf.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_11fIfIf = struct.Struct("<11fIfIf")
